﻿Imports MindFusion.Charting.Wpf

Class Window1
    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        LayoutPanel.SetDock(Legend, Dock.Right)

        series0.StrokeThickness = 0
        series0.Strokes.Add(Brushes.Transparent)
        For i As Integer = 0 To 5
            series0.Fills.Add(GetVisualBrush(Color.FromArgb(255, 145, 191, 141), Color.FromArgb(255, 189, 252, 189), Colors.White, Color.FromArgb(200, 145, 191, 141)))
        Next

        Dim b As VisualBrush = GetVisualBrush(Colors.SteelBlue, Colors.LightSteelBlue, Colors.White, Color.FromArgb(200, Colors.SteelBlue.R, Colors.SteelBlue.G, Colors.SteelBlue.B))
        b.Opacity = 0.3
        barChart.GridFills.Add(b)

        Legend.Background = b
        Legend.BorderBrush = New SolidColorBrush(Color.FromArgb(255, 230, 230, 230))
    End Sub


    Private Function GetVisualBrush(ByVal dark As Color, ByVal light As Color, ByVal verryLight As Color, ByVal cover As Color) As VisualBrush
        Dim t As Double = 10

        Dim grid__1 As New Grid()

        Dim cd1 As ColumnDefinition = New ColumnDefinition()
        cd1.Width = New GridLength(t)
        grid__1.ColumnDefinitions.Add(cd1)

        Dim cd2 As ColumnDefinition = New ColumnDefinition()
        grid__1.ColumnDefinitions.Add(cd2)

        Dim cd3 As ColumnDefinition = New ColumnDefinition()
        cd3.Width = New GridLength(t)
        grid__1.ColumnDefinitions.Add(cd3)


        Dim rd1 As RowDefinition = New RowDefinition()
        rd1.Height = New GridLength(t)
        grid__1.RowDefinitions.Add(rd1)

        Dim rd2 As RowDefinition = New RowDefinition()
        grid__1.RowDefinitions.Add(rd2)

        Dim rd3 As RowDefinition = New RowDefinition()
        rd3.Height = New GridLength(t)
        grid__1.RowDefinitions.Add(rd3)



        'Colors         
        Dim colors1 As Color() = New Color() {dark, verryLight, light, dark}
        Dim colors2 As Color() = New Color() {dark, light, verryLight, dark}
        Dim positions As Double() = New Double() {0, 0.3, 0.6, 1}

        'Geometryes
        Dim border As Border = Nothing
        Dim path As Path = Nothing




        'Center
        border = New Border()
        border.Background = New SolidColorBrush(dark)
        border.VerticalAlignment = VerticalAlignment.Stretch
        border.HorizontalAlignment = HorizontalAlignment.Stretch

        Grid.SetColumnSpan(border, 3)
        Grid.SetRowSpan(border, 3)
        grid__1.Children.Add(border)



        'Top
        border = New Border()
        border.Background = GradientBrush(Orientation.Vertical, colors1, positions)
        Grid.SetColumn(border, 1)
        grid__1.Children.Add(border)



        'Left
        border = New Border()
        border.Background = GradientBrush(Orientation.Horizontal, colors1, positions)
        Grid.SetRow(border, 1)
        grid__1.Children.Add(border)
        border = New Border()
        border.Background = New SolidColorBrush(cover)
        Grid.SetRow(border, 1)
        grid__1.Children.Add(border)



        'Right
        border = New Border()
        border.Background = GradientBrush(Orientation.Horizontal, colors2, positions)
        Grid.SetRow(border, 1)
        Grid.SetColumn(border, 2)
        grid__1.Children.Add(border)
        border = New Border()
        border.Background = New SolidColorBrush(cover)
        Grid.SetRow(border, 1)
        Grid.SetColumn(border, 2)
        grid__1.Children.Add(border)



        'TopLeft
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, 0), New Point(t, t), New Point(t, 0)})
        path.Fill = GradientBrush(Orientation.Vertical, colors1, positions)
        grid__1.Children.Add(path)
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, 0), New Point(t, t), New Point(0, t)})
        path.Fill = GradientBrush(Orientation.Horizontal, colors1, positions)
        grid__1.Children.Add(path)
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, 0), New Point(t, t), New Point(0, t)})
        path.Fill = New SolidColorBrush(cover)
        grid__1.Children.Add(path)



        'TopRight
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, 0), New Point(0, t), New Point(t, 0)})
        path.Fill = GradientBrush(Orientation.Vertical, colors1, positions)
        Grid.SetColumn(path, 2)
        grid__1.Children.Add(path)
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, t), New Point(t, 0), New Point(t, t)})
        path.Fill = GradientBrush(Orientation.Horizontal, colors2, positions)
        Grid.SetColumn(path, 2)
        grid__1.Children.Add(path)
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, t), New Point(t, 0), New Point(t, t)})
        path.Fill = New SolidColorBrush(cover)
        Grid.SetColumn(path, 2)
        grid__1.Children.Add(path)



        'BottomLeft
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, 0), New Point(0, t), New Point(t, 0)})
        path.Fill = GradientBrush(Orientation.Horizontal, colors1, positions)
        Grid.SetRow(path, 2)
        grid__1.Children.Add(path)
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, 0), New Point(0, t), New Point(t, 0)})
        path.Fill = New SolidColorBrush(cover)
        Grid.SetRow(path, 2)
        grid__1.Children.Add(path)



        'BottomRight
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, 0), New Point(t, t), New Point(t, 0)})
        path.Fill = GradientBrush(Orientation.Horizontal, colors2, positions)
        Grid.SetColumn(path, 2)
        Grid.SetRow(path, 2)
        grid__1.Children.Add(path)
        path = New Path()
        path.Data = PathGeometry(New Point() {New Point(0, 0), New Point(t, t), New Point(t, 0)})
        path.Fill = New SolidColorBrush(cover)
        Grid.SetColumn(path, 2)
        Grid.SetRow(path, 2)
        grid__1.Children.Add(path)


        Dim visualBrush As New VisualBrush()
        visualBrush.Visual = grid__1
        Return visualBrush
    End Function

    Private Function PathGeometry(ByVal points As Point()) As PathGeometry
        Dim figure As New PathFigure()
        figure.StartPoint = points(0)
        For i As Integer = 1 To points.Length - 1
            figure.Segments.Add(New LineSegment(points(i), False))
        Next
        Dim pathGeometry__1 As New PathGeometry()
        pathGeometry__1.Figures.Add(figure)
        Return pathGeometry__1
    End Function

    Private Function GradientBrush(ByVal orientation__1 As Orientation, ByVal colors As Color(), ByVal positions As Double()) As LinearGradientBrush
        Dim brush As New LinearGradientBrush()
        For i As Integer = 0 To colors.Length - 1
            Dim [stop] As New GradientStop(colors(i), positions(i))
            brush.GradientStops.Add([stop])
        Next

        brush.StartPoint = New Point(0, 0)
        If orientation__1 = Orientation.Horizontal Then
            brush.EndPoint = New Point(1, 0)
        Else
            brush.EndPoint = New Point(0, 1)
        End If

        Return brush
    End Function
End Class
